src/Entity/Customer.php
<?php

namespace App\Entity;

use App\Repository\CustomerRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: CustomerRepository::class)]
class Customer
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

   

    #[ORM\Column(length: 255)]
    private ?string $address_line1 = null;

    #[ORM\Column(length: 255, nullable: true)]
    private ?string $address_line2 = null;

    #[ORM\Column(length: 255,nullable: true)]
    private ?string $zipcode = null;

    #[ORM\Column(length: 255)]
    private ?string $city = null;

    #[ORM\Column(length: 255,nullable: true)]
    private ?string $country = null;


    #[ORM\OneToMany(mappedBy: 'customer', targetEntity: Orders::class)]
    private Collection $orders;

    #[ORM\OneToOne(inversedBy: 'customer', cascade: ['persist', 'remove'])]
    #[ORM\JoinColumn(nullable: false)]
    private ?User $user = null;

    #[ORM\Column(length: 16)]
    private ?string $phone = null;



    public function __construct()
    {
      
        $this->orders = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

   

    public function getAddressLine1(): ?string
    {
        return $this->address_line1;
    }

    public function setAddressLine1(string $address_line1): self
    {
        $this->address_line1 = $address_line1;

        return $this;
    }

    public function getAddressLine2(): ?string
    {
        return $this->address_line2;
    }

    public function setAddressLine2(?string $address_line2): self
    {
        $this->address_line2 = $address_line2;

        return $this;
    }

    public function getZipcode(): ?string
    {
        return $this->zipcode;
    }

    public function setZipcode(string $zipcode): self
    {
        $this->zipcode = $zipcode;

        return $this;
    }

    public function getCity(): ?string
    {
        return $this->city;
    }

    public function setCity(string $city): self
    {
        $this->city = $city;

        return $this;
    }

    public function getCountry(): ?string
    {
        return $this->country;
    }

    public function setCountry(string $country): self
    {
        $this->country = $country;

        return $this;
    }

   
   
    /**
     * @return Collection<int, Orders>
     */
    public function getOrders(): Collection
    {
        return $this->orders;
    }

    public function addOrder(Orders $order): self
    {
        if (!$this->orders->contains($order)) {
            $this->orders->add($order);
            $order->setCustomer($this);
        }

        return $this;
    }

    public function removeOrder(Orders $order): self
    {
        if ($this->orders->removeElement($order)) {
            // set the owning side to null (unless already changed)
            if ($order->getCustomer() === $this) {
                $order->setCustomer(null);
            }
        }

        return $this;
    }

    public function getUser(): ?User
    {
        return $this->user;
    }

    public function setUser(User $user): self
    {
        $this->user = $user;

        return $this;
    }

    public function getPhone(): ?string
    {
        return $this->phone;
    }

    public function setPhone(string $phone): self
    {
        $this->phone = $phone;

        return $this;
    }

   

   
}

src/Form/CustomerType.php
<?php

namespace App\Form;

use App\Entity\Customer;
use App\Entity\User;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class CustomerType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('phone')
            ->add('address_line1')
            ->add('address_line2')
            ->add('city');
           
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Customer::class,
        ]);
    }
}

src/Controller/CustomerController.php
<?php

namespace App\Controller;

use App\Entity\Customer;
use App\Form\CustomerType;
use App\Repository\CustomerRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

#[Route('/customer')]
class CustomerController extends AbstractController
{
    #[Route('/', name: 'app_customer_index', methods: ['GET'])]
    public function index(CustomerRepository $customerRepository): Response
    {
        return $this->render('customer/index.html.twig', [
            'customers' => $customerRepository->findAll(),
        ]);
    }

    #[Route('/{id}/edit', name: 'app_customer_edit', methods: ['GET', 'POST'])]
    #[Route('/new', name: 'app_customer_new', methods: ['GET', 'POST'])]
    public function new(Customer $customer=null,Request $request, CustomerRepository $customerRepository): Response
    {
        $customer = new Customer();
        $form = $this->createForm(CustomerType::class, $customer);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $customerRepository->save($customer, true);

            return $this->redirectToRoute('app_customer_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('customer/new.html.twig', [
            'customer' => $customer,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_customer_show', methods: ['GET'])]
    public function show(Customer $customer): Response
    {
        return $this->render('customer/show.html.twig', [
            'customer' => $customer,
        ]);
    }

   

    #[Route('/{id}', name: 'app_customer_delete', methods: ['POST'])]
    public function delete(Request $request, Customer $customer, CustomerRepository $customerRepository): Response
    {
        if ($this->isCsrfTokenValid('delete'.$customer->getId(), $request->request->get('_token'))) {
            $customerRepository->remove($customer, true);
        }

        return $this->redirectToRoute('app_customer_index', [], Response::HTTP_SEE_OTHER);
    }
}

templates/customer/_delete_form.html.twig
<form method="post" action="{{ path('app_customer_delete', {'id': customer.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ customer.id) }}">
    <button class="btn">Delete</button>
</form>

templates/customer/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

templates/customer/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Customer{% endblock %}

{% block body %}
    <h1>Edit Customer</h1>

    {{ include('customer/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('app_customer_index') }}">back to list</a>

    {{ include('customer/_delete_form.html.twig') }}
{% endblock %}

templates/customer/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Customer index{% endblock %}

{% block body %}
    <h1>Customer index</h1>

    <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>Phone</th>
                <th>Address_line1</th>
                <th>Address_line2</th>
                <th>Zipcode</th>
                <th>City</th>
                <th>Country</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for customer in customers %}
            <tr>
                <td>{{ customer.id }}</td>
                <td>{{ customer.phone }}</td>
                <td>{{ customer.addressLine1 }}</td>
                <td>{{ customer.addressLine2 }}</td>
                <td>{{ customer.zipcode }}</td>
                <td>{{ customer.city }}</td>
                <td>{{ customer.country }}</td>
                <td>
                    <a href="{{ path('app_customer_show', {'id': customer.id}) }}">show</a>
                    <a href="{{ path('app_customer_edit', {'id': customer.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="8">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('app_customer_new') }}">Create new</a>
{% endblock %}

templates/customer/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Customer{% endblock %}

{% block body %}
    <h1>Create new Customer</h1>

    {{ include('customer/_form.html.twig') }}

    <a href="{{ path('app_customer_index') }}">back to list</a>
{% endblock %}

templates/customer/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Customer{% endblock %}

{% block body %}
    <h1>Customer</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ customer.id }}</td>
            </tr>
            <tr>
                <th>Phone</th>
                <td>{{ customer.phone }}</td>
            </tr>
            <tr>
                <th>Address_line1</th>
                <td>{{ customer.addressLine1 }}</td>
            </tr>
            <tr>
                <th>Address_line2</th>
                <td>{{ customer.addressLine2 }}</td>
            </tr>
            <tr>
                <th>Zipcode</th>
                <td>{{ customer.zipcode }}</td>
            </tr>
            <tr>
                <th>City</th>
                <td>{{ customer.city }}</td>
            </tr>
            <tr>
                <th>Country</th>
                <td>{{ customer.country }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('app_customer_index') }}">back to list</a>

    <a href="{{ path('app_customer_edit', {'id': customer.id}) }}">edit</a>

    {{ include('customer/_delete_form.html.twig') }}
{% endblock %}